<?php

////////////////////////////////////////
// Nom du plugin : Qui est en ligne ?
// Date de sortie : 20/07/2005
// Site de l'auteur : http://jebulle.net
////////////////////////////////////////
// Encodage du fichier : UTF-8
// Utilisation des tabulations : Oui
// 1 tabulation = 4 caractères
// Fins de lignes = LF (Unix)
////////////////////////////////////////

/***********************************************************************

  Copyright (C) 2005  SamRay1024 (webmaster@jebulle.net)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

// Make sure no one attempts to run this script "directly"
if (!defined('PUN'))
	exit;

// Tell admin_loader.php that this is indeed a plugin and that it is loaded
define('PUN_PLUGIN_LOADED', 1);

// Définitions
define( 'PLUGIN_VERSION',		'1.0' );
define( 'PLUGIN_LOCALE',		'Fr' );
define( 'PLUGIN_TITLE',			'Qui est en ligne ?' );
define( 'PLUGIN_HELP',			'<strong>'.PLUGIN_TITLE.'</strong> est un plugin tr&egrave;s simple qui dresse la liste des personnes
								connect&eacute;es &agrave; un forum PunBB. Il reconna&icirc;t quelques robots (pensez &agrave; mettre
								&agrave; jour la liste des IP dans le code source du plugin). La liste des robots n\'est pas exhaustive.
								Vous pouvez en rajouter au besoin et &agrave; loisir.' );

define( 'PLUGIN_INFOS_TITLE',	'Informations' );
define( 'PLUGIN_NB_ONLINE',		'Nombre de personnes connect&eacute;es' );
define( 'PLUGIN_LIST_TITLE',	'Liste des personnes connect&eacute;es' );
define( 'PLUGIN_COL_IDENTITY',	'Identit&eacute;' );
define( 'PLUGIN_COL_TIME',		'Derni&egrave;re action il y a' );
define( 'PLUGIN_COL_IDLE',		'Inactif' );
define( 'PLUGIN_YES',			'Oui' );
define( 'PLUGIN_NO',			'Non' );

define( 'PLUGIN_ERROR_SQL',		'Impossible de lire la liste des personnes connect&eacute;.' );

//
// Robots connu (Vous pouvez compléter cette liste à loisir
//
$aRobots = array();

// Moteur : MSN (Microsoft)
$aRobots['207.68.146'] = 'MSNBot';
$aRobots['65.54.188'] = 'MSNBot';
$aRobots['207.46.98.116'] = 'MSNBot';
$aRobots['207.46'] = 'MSNBot';

// Moteur : Google
$aRobots['66.249'] = 'Googlebot';

// Moteur : Yahoo!
$aRobots['66.196'] = 'Yahoo! Slurp';
$aRobots['68.142'] = 'Yahoo! Slurp';

// Moteur : Voila
$aRobots['195.101.94'] = 'VoilaBot';

// Moteur : WiseNut
$aRobots['64.241.243.65'] = 'ZyBorg';
$aRobots['209.249.67.1'] = 'ZyBorg';
$aRobots['64.241.242.177'] = 'ZyBorg';

// Moteur : Fast
$aRobots['66.77.73'] = 'Fast Web Crawler';

// Moteur : DeepIndex
$aRobots['62.212.117.198'] = 'DeepIndex bot';

// Moteur : Teoma
$aRobots['65.214.36'] = 'Teoma';
$aRobots['65.214.38.10'] = 'DirectHit';

// Moteur : Whalhello
$aRobots['212.127.141.180'] = 'appie';
$aRobots['213.73.184'] = 'appie';

// Moteur : Gigablast
$aRobots['216.243.113.1'] = 'Gigablast, Inc.';
$aRobots['66.154'] = 'Gigablast, Inc.';

// Moteur : Mirago
$aRobots['217.205.60.225'] = 'HenriLeRobotMirago';

// Moteur : picsearch
$aRobots['62.119.21.157'] = 'Psbot';

// Moteur : Szukacz
$aRobots['193.218.115.6'] = 'Szukacz robot';

// Moteur : Openfind
$aRobots['210.59.144.149'] = 'Openbot';
$aRobots['66.237.60.22'] = 'Openbot';

// Moteur : Naver
$aRobots['218.145.25'] = 'dloader';

// Moteur : http://www.whois.sc
$aRobots['64.246.161'] = 'SurveyBot';

// Moteur : Pompos (http://dir.com - Groupe Iliad)
$aRobots['212.27.41'] = 'Pompos';
$aRobots['212.27.33'] = 'Pompos';

// Lecture de la table Online
$sReqSQL = 'SELECT * FROM '.$db->prefix.'online';
$rRes = $db->query($sReqSQL) or error(PLUGIN_ERROR_SQL, __FILE__, __LINE__, $db->error());
$iNbConnectes = $db->num_rows($rRes);

// Display the admin navigation menu
generate_admin_menu($plugin);

?>
	<div class="block">
		<h2><span><?php echo PLUGIN_TITLE; ?> - v<?php echo PLUGIN_VERSION ?> - <?php echo PLUGIN_LOCALE; ?></span></h2>
		<div class="box">
			<div class="inbox">
				<p><?php echo PLUGIN_HELP; ?></p>
			</div>
		</div>
	</div>
	
	<div class="block">
		<h2 class="block2"><span><?php echo PLUGIN_INFOS_TITLE; ?></span></h2>
		<div class="box">
			<div class="inbox">
			
				<p><?php echo PLUGIN_NB_ONLINE; ?> : <strong><?php echo $iNbConnectes; ?></strong></p>
			
				<fieldset>
					<legend><?php echo PLUGIN_LIST_TITLE; ?></legend>
					<div class="infldset">
					
						<table cellspacing="0">
				
							<thead>
								<tr>
									<th style="width: 50%;"><?php echo PLUGIN_COL_IDENTITY;?></th>
									<th style="witdh: 25%;"><?php echo PLUGIN_COL_TIME;?></th>
									<th style="width: 25%;"><?php echo PLUGIN_COL_IDLE;?></th>
								</tr>
							</thead>
					
							<tbody>
								<?php
								for ($i=0 ; $i<$iNbConnectes ; $i++) {
									$aTuple = $db->fetch_assoc($rRes);
								?>
								<tr>
									<td>
										<?php
										if( is_numeric( str_replace( '.', '', $aTuple['ident'] ) ) )
										{
											$sRobot = '';
											foreach ( $aRobots as $key => $value )
												if( strpos( $aTuple['ident'], $key ) !== false )
													$sRobot = $value;			
											
											if( $sRobot != '' )
												echo '<strong>',$sRobot,'</strong> - ';
											
											echo '<a href="http://www.netastuces.org/new/?page=whois&query=',$aTuple['ident'],'&submit=OK">',$aTuple['ident'],'</a>';
										}
										else echo '<a href="profile.php?id='.$aTuple['user_id'].'">'.$aTuple['ident'].'</a>';
										?>
									</td>
									<td><?php echo date("H \h\e\u\\r\e\s i \m\i\\n\u\\t\e\s", mktime(0,0, time() - $aTuple['logged'] ) ); ?></td>
									<td><?php echo ( $aTuple['idle'] == 1 ) ? PLUGIN_YES : PLUGIN_NO; ?></td> 
								</tr>
								<?php
								}
								?>
							</tbody>
							
						</table>
						
					</div>
				</fieldset>
			</div>
		</div>
	</div>
